﻿--
-- ExchangeableBody
-- specialization for swap body, to detach from chassis
-- 
--
-- @author Bluebaby210 www.mod-portal.de
-- @date 31.07.2013
--
-- @version: v 1.0 release at modcontest 2013
--
--

ExchangeableBody = {};

function ExchangeableBody.prerequisitesPresent(specializations)
    return true;
end;

function ExchangeableBody:load(xmlFile)

	self.detachFromAllrounder = SpecializationUtil.callSpecializationsFunction("detachFromAllrounder");
	self.decideSelectable = SpecializationUtil.callSpecializationsFunction("decideSelectable");

	self.attacherVehicle = nil;
	self.easyCutAttacher = nil;
	self.isSelectable = false;
	
	self.newBodySchemaOverlay = {};
	self.newBodySchemaOverlay.overlay = self.schemaOverlay.overlay;
	self.newBodySchemaOverlay.overlaySelected = self.schemaOverlay.overlaySelected;
	
	self.bodySchema = self.schemaOverlay;
	
	self.firstRun = true;
end;

function ExchangeableBody:delete()
end;

function ExchangeableBody:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ExchangeableBody:keyEvent(unicode, sym, modifier, isDown)
end;

function ExchangeableBody:readStream(streamId, connection)
	self.firstRun = streamReadBool(streamId);
end;


function ExchangeableBody:writeStream(streamId, connection)
	streamWriteBool(streamId, self.firstRun);
end;

function ExchangeableBody:readStreamUpdate(streamId, connection)	
end;

function ExchangeableBody:writeStreamUpdate(streamId, connection)
end;

function ExchangeableBody:updateTick(dt)
end;

function ExchangeableBody:update(dt)

	if self.firstRun then
		if self.attacherVehicle ~= nil then
			for k,v in pairs(self.attacherVehicle.attachedImplements) do
				if self.attacherVehicle.detachBody ~= nil then
					self.schemaOverlay = nil;
					self.isSelectable = false;
				end;
			end;
		end;
		self.firstRun = false;
	end;
	
end;

function ExchangeableBody:draw()
end;

function ExchangeableBody:detachFromAllrounder()
	if not self.isSelectable then
		self.attacherVehicle:detachImplementByObject(self);
	end;
end;

function ExchangeableBody:onAttach(attacherVehicle)
	self.attacherVehicle = attacherVehicle;
	self.bodyAttacher = attacherVehicle.attacherVehicle;
	self:decideSelectable();
end;

function ExchangeableBody:onDetach()
	self.attacherVehicle = nil;
	self.bodyAttacher = nil;
	self.schemaOverlay = {};
	self.schemaOverlay = self.bodySchema;
end;

function ExchangeableBody:decideSelectable()
		if self.bodyAttacher ~= nil then
			for k,v in pairs(self.bodyAttacher.attachedImplements) do
				if self.attacherVehicle.detachBody ~= nil then
					self.schemaOverlay = nil;
				end;
			end;
		end;
end;